## s390-tools 2.35.0

=== Makefile ===
# Include common definitions
include common.mak

#
# BASELIBS: Libraries that have no dependency to other libraries in s390-tools
# LIBS: Libraries that can have a dependency to base libraries
# TOOLS: Tools that can have a dependency to base libraries or libraries
#
ifeq ($(HOST_ARCH),s390x)
BASELIB_DIRS = libutil libseckey
LIB_DIRS = libvtoc libzds libdasd libccw libvmcp libekmfweb \
	   libkmipclient libcpumf libap libpv
TOOL_DIRS = zipl zdump fdasd dasdfmt dasdview tunedasd \
	   tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf \
	   vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools \
	   ziomon iucvterm hyptop cmsfs-fuse qethqoat zfcpdump zdsfs cpumf \
	   systemd hmcdrvfs cpacfstats zdev dump2tar zkey netboot etc zpcictl \
	   genprotimg lsstp hsci hsavmcore chreipl-fcp-mpath ap_tools rust

else
BASELIB_DIRS =
LIB_DIRS = libpv
TOOL_DIRS = genprotimg rust
endif

SUB_DIRS = $(BASELIB_DIRS) $(LIB_DIRS) $(TOOL_DIRS)

all: $(TOOL_DIRS)
clean: $(TOOL_DIRS)
install: $(TOOL_DIRS)

#
# For simple "make" we explicitly set the MAKECMDGOALS to "all".
#
ifeq ($(MAKECMDGOALS),)
MAKECMDGOALS = all
endif

#
# We have to build the base libraries before the other libraries are built,
# and then build the other libraries before the tools are built. Otherwise the
# other libraries and tools would trigger parallel "make -C" builds for the
# base libraries and the other libraries in case of "make -j".
#
# MAKECMDGOALS contains the list of goals, e.g. "clean all". We use
# "foreach" to generate a ";" separated list of "make -C <target>".
# For example the the expansion for "make clean all" is:
#
# $(MAKE) -C $@ [..] clean ;  $(MAKE) -C $@ [...] all ;
#
# This ensures that the commandline targets are serialized and also "make -j"
# works as expected, e.g. "make clean all -j 20".
#

$(TOOL_DIRS): $(LIB_DIRS)
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) HOST_ARCH=$(HOST_ARCH) $(goal) ;)
.PHONY: $(TOOL_DIRS)

$(LIB_DIRS): $(BASELIB_DIRS)
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) HOST_ARCH=$(HOST_ARCH) $(goal) ;)
.PHONY: $(LIB_DIRS)

$(BASELIB_DIRS):
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) HOST_ARCH=$(HOST_ARCH) $(goal) ;)
.PHONY: $(BASELIB_DIRS)

=== ap_tools/Makefile ===
include ../common.mak

MDEVCTL_DIR = /usr/lib/mdevctl/
MDEVCTL_SCRIPTS = /usr/lib/mdevctl/scripts.d/
MDEVCTL_CALLOUTS = /usr/lib/mdevctl/scripts.d/callouts/
MDEVCTL_DEP_DIR = /etc/mdevctl.d/
MDEVCTL_DEP_SCRIPTS = /etc/mdevctl.d/scripts.d/
MDEVCTL_DEP_CALLOUTS = /etc/mdevctl.d/scripts.d/callouts/

libs =	$(rootdir)/libap/libap.a \
	$(rootdir)/libutil/libutil.a

ifeq (${HAVE_JSONC},0)
all:
	$(SKIP) HAVE_JSONC=0

install:
	$(SKIP) HAVE_JSONC=0
else
LDLIBS += -ljson-c

all: ap-check

ap-check: ap-check.o $(libs)

install: all
	@if [ ! -d $(DESTDIR)$(MDEVCTL_CALLOUTS) ]; then \
		mkdir -p $(DESTDIR)$(MDEVCTL_CALLOUTS); \
		chown $(OWNER):$(GROUP) $(DESTDIR)$(MDEVCTL_DIR); \
		chown $(OWNER):$(GROUP) $(DESTDIR)$(MDEVCTL_SCRIPTS); \
		chown $(OWNER):$(GROUP) $(DESTDIR)$(MDEVCTL_CALLOUTS); \
		chmod 755 $(DESTDIR)$(MDEVCTL_DIR); \
		chmod 755 $(DESTDIR)$(MDEVCTL_SCRIPTS); \
		chmod 755 $(DESTDIR)$(MDEVCTL_CALLOUTS); \
	fi; \
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 ap-check \
		$(DESTDIR)$(MDEVCTL_CALLOUTS)
	@if [ ! -d $(DESTDIR)$(MDEVCTL_DEP_CALLOUTS) ]; then \
		mkdir -p $(DESTDIR)$(MDEVCTL_DEP_CALLOUTS); \
		chown $(OWNER):$(GROUP) $(DESTDIR)$(MDEVCTL_DEP_DIR); \
		chown $(OWNER):$(GROUP) $(DESTDIR)$(MDEVCTL_DEP_SCRIPTS); \
		chown $(OWNER):$(GROUP) $(DESTDIR)$(MDEVCTL_DEP_CALLOUTS); \
		chmod 755 $(DESTDIR)$(MDEVCTL_DEP_DIR); \
		chmod 755 $(DESTDIR)$(MDEVCTL_DEP_SCRIPTS); \
		chmod 755 $(DESTDIR)$(MDEVCTL_DEP_CALLOUTS); \
	fi; \
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 ap-check.sh \
		$(DESTDIR)$(MDEVCTL_DEP_CALLOUTS)
endif

clean:
	rm -f *.o *~ ap-check core

.PHONY: all install clean

=== chreipl-fcp-mpath/Makefile ===
# SPDX-License-Identifier: MIT
#
# chreipl-fcp-mpath: use multipath information to change FCP IPL target
# (C) Copyright IBM Corp. 2021
#
# Uses the following system-utilities (and shell-builtins):
#   Utilities list in GNU Make Conventions:
#     https://www.gnu.org/software/make/manual/make.html#Utilities-in-Makefiles
#   Those necessary for sourced Makefiles:
#     - ../common.mak
#     - chreipl-fcp-mpath.mak
#   bash:
#     - bash
#   GNU coreutils:
#     - sha256sum
# If $(ENABLE_DOC) is `1`:
#   GNU awk:
#     - gawk

override .SHELLFLAGS	:= -O globstar -O nullglob -O extglob -c

# Include common s390-tools definitions
include ../common.mak

# Include common chreipl-fcp-mpath definitions
include chreipl-fcp-mpath.mak

# Local setting: .make.config
#	You may create a file named like this in the same directory as this
#	Makefile, and customize the build this way (e.g. re-define variables
#	set in `chreipl-fcp-mpath.mak`, or define a `CHREIPLZFCPMP_POST_INSTALL`
#	that is automatically called after each installation)
ifneq ($(wildcard .make.config),)
include $(wildcard .make.config)
endif

#
## Build
#

.PHONY: chreipl-fcp-mpath chreipl-fcp-mpath-clean
chreipl-fcp-mpath:
chreipl-fcp-mpath-clean:
all: chreipl-fcp-mpath
clean: chreipl-fcp-mpath-clean

# common function used in the helper scripts
CHREIPL_FCP_MPATH_COMMON	:=					\
	chreipl-fcp-mpath-common.sh
CHREIPL_FCP_MPATH_UDEV_HELPER	:=					\
	chreipl-fcp-mpath-is-ipl-tgt					\
	chreipl-fcp-mpath-is-ipl-vol					\
	chreipl-fcp-mpath-is-reipl-zfcp					\
	chreipl-fcp-mpath-record-volume-identifier			\
	chreipl-fcp-mpath-try-change-ipl-path

$(CHREIPL_FCP_MPATH_UDEV_HELPER) $(CHREIPL_FCP_MPATH_COMMON): $(MAKEFILE_LIST)
$(CHREIPL_FCP_MPATH_UDEV_HELPER) $(CHREIPL_FCP_MPATH_COMMON): % : %.in
	$(call chreiplzfcpmp-sed-buildvar-replace,$(<),$(@))
	chmod a+x $(@)

$(CHREIPL_FCP_MPATH_UDEV_HELPER): $(CHREIPL_FCP_MPATH_COMMON)

.PHONY: chreipl-fcp-mpath-udev-helper-clean
chreipl-fcp-mpath-udev-helper-clean:
	rm -f $(CHREIPL_FCP_MPATH_UDEV_HELPER) $(CHREIPL_FCP_MPATH_COMMON)

udev/rules.d/70-chreipl-fcp-mpath.rules: $(CHREIPL_FCP_MPATH_UDEV_HELPER)

chreipl-fcp-mpath: udev/rules.d/70-chreipl-fcp-mpath.rules
chreipl-fcp-mpath-clean: chreipl-fcp-mpath-udev-helper-clean

dracut/dracut.conf.d/70-chreipl-fcp-mpath.conf: $(MAKEFILE_LIST)
dracut/dracut.conf.d/70-chreipl-fcp-mpath.conf: % : %.in
	$(call chreiplzfcpmp-sed-buildvar-replace,$(<),$(@))

.PHONY: chreipl-fcp-mpath-dracut-clean
chreipl-fcp-mpath-dracut-clean:
	rm -f dracut/dracut.conf.d/70-chreipl-fcp-mpath.conf

chreipl-fcp-mpath: dracut/dracut.conf.d/70-chreipl-fcp-mpath.conf
chreipl-fcp-mpath-clean: chreipl-fcp-mpath-dracut-clean

ifeq ($(ENABLE_DOC),1)

.PHONY: chreipl-fcp-mpath-doc
chreipl-fcp-mpath-doc: README.html chreipl-fcp-mpath.7

ifeq ($(ENABLE_DOC_PDF),1)
chreipl-fcp-mpath-doc: README.pdf

README.pdf: PANDOCFLAGS += -M title="chreipl-fcp-mpath" -M subtitle="README"
endif

README.html: PANDOCFLAGS += -M title="chreipl-fcp-mpath" -M subtitle="README"

chreiplzfcpmp-doc-man-meta =						\
	-M title="CHREIPL-FCP-MPATH"					\
	-V header="Administrator Manual"				\
	-V section="7"							\
	-V footer="s390-tools $(S390_TOOLS_RELEASE)"

chreipl-fcp-mpath.7: PANDOCFLAGS += $(chreiplzfcpmp-doc-man-meta)
chreipl-fcp-mpath.7: .chreipl-fcp-mpath.7.cksum

.INTERMEDIATE: chreipl-fcp-mpath.md
chreipl-fcp-mpath.md: README.md
	gawk -- '/NOT-IN-MAN \{/,/NOT-IN-MAN \}/ { next } { print }' $(<) > $(@)

.chreipl-fcp-mpath.7.cksum: README.md
	sha256sum $(<) > $(@)

.PHONY: chreipl-fcp-mpath-doc-clean
chreipl-fcp-mpath-doc-clean:
	rm -f README.html README.pdf chreipl-fcp-mpath.md

chreipl-fcp-mpath: chreipl-fcp-mpath-doc
chreipl-fcp-mpath-clean: chreipl-fcp-mpath-doc-clean

else # $(ENABLE_DOC) != 1

# We bundle a pre-cooked man page with the source-code so that distributions
# don't need `pandoc` in order to be able to ship the man page. As of this
# writing multiple distributions don't have a packaged version of it.
#
# In order to remember to regenerate this pre-cooked version whenever the
# README.md is changed, we also generate a checksum of the README.md, bundle
# that as well, and compare that whenever `make` is called. This way, the
# freshness of the man page can be checked, even if `pandoc` is not available,
# or ENABLE_DOC disabled.

MANPAGE_FRESH	:= $(shell sha256sum --check .chreipl-fcp-mpath.7.cksum >/dev/null && echo 1 || echo 0)
ifeq ($(MANPAGE_FRESH),0)
$(warning chreipl-fcp-mpath.7 is outdated, please regenerate it by calling `make ENABLE_DOC=1`)
endif

endif # $(ENABLE_DOC) == 1

#
## Install
#

.PHONY: chreipl-fcp-mpath-install
# The content of `CHREIPLZFCPMP_POST_INSTALL` (bash script) is automatically
# called *after* installing chreipl-fcp-mpath during `make install`. If not
# defined (the default), nothing happens. You may define this on the make
# command line, or by creating a `.make.config` and defining the variable in
# there.
chreipl-fcp-mpath-install:
	$(CHREIPLZFCPMP_POST_INSTALL)

install: chreipl-fcp-mpath-install

# install udev rules
INSTDIRS += $(UDEVRULESDIR)
$(DESTDIR)$(UDEVRULESDIR): install_dirs

.PHONY: chreipl-fcp-mpath-install-udev-rules
chreipl-fcp-mpath-install-udev-rules: | $(DESTDIR)$(UDEVRULESDIR)
chreipl-fcp-mpath-install-udev-rules: udev/rules.d/70-chreipl-fcp-mpath.rules
	$(INSTALL_DATA) -t $(DESTDIR)$(UDEVRULESDIR)			\
		udev/rules.d/70-chreipl-fcp-mpath.rules

chreipl-fcp-mpath-install: chreipl-fcp-mpath-install-udev-rules

# install udev helper programs
INSTDIRS += $(UDEVDIR)
$(DESTDIR)$(UDEVDIR): install_dirs

.PHONY: chreipl-fcp-mpath-install-udev-helper
chreipl-fcp-mpath-install-udev-helper: | $(DESTDIR)$(UDEVDIR)
chreipl-fcp-mpath-install-udev-helper: $(CHREIPL_FCP_MPATH_UDEV_HELPER)
	$(INSTALL_EXEC) -t $(DESTDIR)$(UDEVDIR) $(CHREIPL_FCP_MPATH_UDEV_HELPER)

chreipl-fcp-mpath-install: chreipl-fcp-mpath-install-udev-helper

# install common library files
INSTDIRS += $(CHREIPLZFCPMPDIR)
$(DESTDIR)$(CHREIPLZFCPMPDIR): install_dirs

.PHONY: chreipl-fcp-mpath-install-libfiles
chreipl-fcp-mpath-install-libfiles: | $(DESTDIR)$(CHREIPLZFCPMPDIR)
chreipl-fcp-mpath-install-libfiles: $(CHREIPL_FCP_MPATH_COMMON)
	$(INSTALL_DATA) -t $(DESTDIR)$(CHREIPLZFCPMPDIR)		\
		$(CHREIPL_FCP_MPATH_COMMON)

chreipl-fcp-mpath-install: chreipl-fcp-mpath-install-libfiles

ifeq ($(HAVE_DRACUT),1)

# install dracut config files
INSTDIRS += $(DRACUTCONFDIR)
$(DESTDIR)$(DRACUTCONFDIR): install_dirs

.PHONY: chreipl-fcp-mpath-install-dracut-config
chreipl-fcp-mpath-install-dracut-config: | $(DESTDIR)$(DRACUTCONFDIR)
chreipl-fcp-mpath-install-dracut-config: dracut/dracut.conf.d/70-chreipl-fcp-mpath.conf
	$(INSTALL_DATA) -t $(DESTDIR)$(DRACUTCONFDIR)			\
		dracut/dracut.conf.d/70-chreipl-fcp-mpath.conf

chreipl-fcp-mpath-install: chreipl-fcp-mpath-install-dracut-config

endif

# chreipl-fcp-mpath: install man page
INSTDIRS += $(MANDIR)
$(DESTDIR)$(MANDIR)/man7: install_dirs

.PHONY: chreipl-fcp-mpath-install-man-page
chreipl-fcp-mpath-install-man-page: | $(DESTDIR)$(MANDIR)/man7
chreipl-fcp-mpath-install-man-page: chreipl-fcp-mpath.7
	$(INSTALL_DATA) -t $(DESTDIR)$(MANDIR)/man7			\
		chreipl-fcp-mpath.7

chreipl-fcp-mpath-install: chreipl-fcp-mpath-install-man-page

#
## Utility
#

# Utilities for the debug feature of chreipl-fcp-mpath-common.sh.
#
# When `chreipl-fcp-mpath` is built with D=1 (default is D=0), each run
# of one of the helper scripts will create a debug log in $(DEBUGOUTDIR)
# (default: /run/udev) which among other things contains the complete shell
# trace of that script run, with some added information that would not be
# inspectable otherwise with just the trace.
#
# There is currently no way of enabling/disabling this at runtime.
#
# chreipl-fcp-mpath-common.sh defines debug log file name as
# "chreiplzfcpmp-${debug_trace_tag}-${SEQNUM:-0}.XXXXXXXXXX" where SEQNUM is a
# udev rule environment variable and each X is replaced with some [[:alnum:]]
# by mktemp. For a definition of `debug_trace_tag`, please see the comments
# in the source.
#
# The following targets can be used for some simple access and filtering of the
# logs during development.

DEBUG_LOG_GLOB = $(DEBUGOUTDIR)/chreiplzfcpmp-[[:digit:]][[:digit:]][[:alpha:]][[:alpha:]][[:alpha:]][[:alpha:]]-+([[:digit:]]).[[:alnum:]][[:alnum:]][[:alnum:]][[:alnum:]][[:alnum:]][[:alnum:]][[:alnum:]][[:alnum:]][[:alnum:]][[:alnum:]]

# display all debug log files on the system
.PHONY: chreipl-fcp-mpath-debug-logs
chreipl-fcp-mpath-debug-logs:
	@ls -1d $(DEBUG_LOG_GLOB)

# display only debug log files of script runs that exited with status 0 (= good)
#
# XXX: `sed -n -e '$p'` is used instead of `tail -n1` to prevent an other
#      dependency just for that (both invocations do the same thing).
.PHONY: chreipl-fcp-mpath-debug-logs-filter-good
chreipl-fcp-mpath-debug-logs-filter-good:
	@for lg in $(DEBUG_LOG_GLOB); do				\
		sed -e '/^+ trap_exit$$/,/^+ trap - EXIT$$/d' "$${lg}"	\
		    | sed -n -e '$$p'					\
		    | grep -q -e '^+ exit 0$$'		|| continue;	\
		ls -d "$${lg}";						\
	done

# display only debug log files of script runs that didn't exit with status 0
# (= bad)
.PHONY: chreipl-fcp-mpath-debug-logs-filter-bad
chreipl-fcp-mpath-debug-logs-filter-bad:
	@for lg in $(DEBUG_LOG_GLOB); do				\
		sed -e '/^+ trap_exit$$/,/^+ trap - EXIT$$/d' "$${lg}"	\
		    | sed -n -e '$$p'					\
		    | grep -q -e '^+ exit 0$$'		&& continue;	\
		ls -d "$${lg}";						\
	done

.PHONY: chreipl-fcp-mpath-debug-logs-clean
chreipl-fcp-mpath-debug-logs-clean:
	rm -f $(DEBUG_LOG_GLOB)

=== cmsfs-fuse/Makefile ===
#!/usr/bin/make -f

include ../common.mak

ifeq (${HAVE_FUSE},0)

all:
	$(SKIP) HAVE_FUSE=0

install:
	$(SKIP) HAVE_FUSE=0

else

check_dep:
	$(call check_dep, \
		"cmsfs-fuse", \
		"fuse.h", \
		"fuse3-devel or libfuse3-dev", \
		"HAVE_FUSE=0", \
		"-DFUSE_USE_VERSION=30")

all: check_dep cmsfs-fuse

FUSE_CFLAGS = $(shell $(PKG_CONFIG) --silence-errors --cflags fuse3)
FUSE_LDLIBS = $(shell $(PKG_CONFIG) --silence-errors --libs fuse3)
ALL_CFLAGS += -DHAVE_SETXATTR $(FUSE_CFLAGS)
LDLIBS += $(FUSE_LDLIBS) -lm

OBJECTS = cmsfs-fuse.o dasd.o amap.o config.o

CMSFS_FUSE_DIR = $(SYSCONFDIR)/cmsfs-fuse
CONFIG_FILES = filetypes.conf

libs = $(rootdir)/libutil/libutil.a

cmsfs-fuse: $(OBJECTS) $(libs)

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 cmsfs-fuse \
		$(DESTDIR)$(USRBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 cmsfs-fuse.1 \
		$(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -g $(GROUP) -o $(OWNER) -d $(DESTDIR)$(CMSFS_FUSE_DIR)
	for cnf in $(CONFIG_FILES); do \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 etc/$$cnf $(DESTDIR)$(CMSFS_FUSE_DIR) ; \
	done

endif

clean:
	rm -f cmsfs-fuse *.o

.PHONY: all install clean check_dep

=== cpacfstats/Makefile ===
include ../common.mak

ifeq (${HAVE_LIBUDEV},0)

all:
	$(SKIP) HAVE_LIBUDEV=0

install:
	$(SKIP) HAVE_LIBUDEV=0

else

check_dep:
	$(call check_dep, \
		"cpacfstatsd", \
		"libudev.h", \
		"systemd-devel", \
		"HAVE_LIBUDEV=0")

ALL_CPPFLAGS += -DVERSION=$(VERSION)

all:		check_dep cpacfstats cpacfstatsd

cpacfstatsd:	cpacfstatsd.o stats_sock.o perf_crypto.o cpacfstats_common.o \
				$(rootdir)/libutil/libutil.a
		$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -ludev -lpthread -o $@

cpacfstats:	cpacfstats.o stats_sock.o cpacfstats_common.o
		$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

install: 	all
		$(INSTALL) -m 755 cpacfstatsd   $(DESTDIR)$(USRSBINDIR)
		$(INSTALL) -m 755 cpacfstats    $(DESTDIR)$(USRBINDIR)
		$(INSTALL) -m 644 cpacfstatsd.8 $(DESTDIR)$(MANDIR)/man8
		$(INSTALL) -m 644 cpacfstats.1  $(DESTDIR)$(MANDIR)/man1

endif

clean:
		rm -f *.o *~ cpacfstatsd cpacfstats

.PHONY: all clean install check_dep

=== dasdinfo/Makefile ===
include ../common.mak

libs = $(rootdir)/libutil/libutil.a \
       $(rootdir)/libdasd/libdasd.a

all: dasdinfo

dasdinfo: dasdinfo.o $(libs)

install: all
	$(INSTALL) -d -m 755 $(DESTDIR)$(BINDIR) \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 dasdinfo $(DESTDIR)$(BINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 dasdinfo.8 \
		$(DESTDIR)$(MANDIR)/man8

clean:
	rm -f *.o *~ dasdinfo core

.PHONY: all install clean

=== genprotimg/Makefile ===
# Common definitions
include ../common.mak

.DEFAULT_GOAL := all

PKGDATADIR := "$(TOOLS_DATADIR)/genprotimg"
TESTS :=
SUBDIRS := boot src man
RECURSIVE_TARGETS := all-recursive install-recursive clean-recursive

all: all-recursive

install: install-recursive
	$(INSTALL) -d -m 755 "$(DESTDIR)$(PKGDATADIR)"
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 samples/check_hostkeydoc "$(DESTDIR)$(PKGDATADIR)"

clean: clean-recursive

$(RECURSIVE_TARGETS):
	@target=`echo $@ |sed s/-recursive//`; \
		for d in $(SUBDIRS); do \
			$(MAKE) -C $$d $$target || exit 1; \
		done

.PHONY: all install clean $(RECURSIVE_TARGETS)

=== libap/Makefile ===
include ../common.mak

lib = libap.a

check-dep-json:
	touch check-dep-json
ifneq (${HAVE_JSONC},0)
	$(call check_dep, \
		"libap", \
		"json-c/json.h", \
		"json-c-devel", \
		"HAVE_JSONC=0")
ALL_CPPFLAGS += -DHAVE_JSONC
endif

all: $(lib)
objects = ap.o

$(lib): $(objects)

$(objects): check-dep-json

install: all

clean:
	rm -f *.o check-dep-lock check-dep-json $(lib)

=== libccw/Makefile ===
include ../common.mak

lib = libccw.a

all: $(lib)

objects = ccw.o

$(lib): $(objects)

install: all

clean:
	rm -f *.o $(lib)

=== libcpumf/Makefile ===
include ../common.mak

lib = libcpumf.a

examples = libcpumf_example

all: $(lib)
examples: $(lib) $(examples)

objects = libcpumf_pmutype.o libcpumf_cpuset.o libcpumf_support.o

$(lib): $(objects)

install: all

libcpumf_example: libcpumf_example.o $(lib) $(rootdir)/libutil/libutil.a

clean:
	rm -f *.o $(lib) $(examples)

=== libekmfweb/Makefile ===
include ../common.mak

VERSION = 1.0
VERM = $(shell echo $(VERSION) | cut -d '.' -f 1)

ifneq (${HAVE_OPENSSL},0)
	ifneq (${HAVE_JSONC},0)
		ifneq (${HAVE_LIBCURL},0)
			BUILD_TARGETS += libekmfweb.so.$(VERSION)
			INSTALL_TARGETS += install-libekmfweb.so.$(VERSION)
		else
			BUILD_TARGETS += skip-libekmfweb-curl
			INSTALL_TARGETS += skip-libekmfweb-curl
		endif
	else
		BUILD_TARGETS += skip-libekmfweb-jsonc
		INSTALL_TARGETS += skip-libekmfweb-jsonc
	endif
else
	BUILD_TARGETS += skip-libekmfweb-openssl
	INSTALL_TARGETS += skip-libekmfweb-openssl
endif

libs = $(rootdir)/libseckey/libseckey.a

TMPFILE := $(shell mktemp)

detect-openssl-version.dep:
	echo "#include <openssl/opensslv.h>" > $(TMPFILE)
	echo "#include <openssl/evp.h>" >> $(TMPFILE)
	echo "#ifndef OPENSSL_VERSION_PREREQ" >> $(TMPFILE)
	echo "  #if defined(OPENSSL_VERSION_MAJOR) && defined(OPENSSL_VERSION_MINOR)" >> $(TMPFILE)
	echo "    #define OPENSSL_VERSION_PREREQ(maj, min) \\" >> $(TMPFILE)
	echo "                 ((OPENSSL_VERSION_MAJOR << 16) + \\" >> $(TMPFILE)
	echo "                  OPENSSL_VERSION_MINOR >= ((maj) << 16) + (min))" >> $(TMPFILE)
	echo "  #else" >> $(TMPFILE)
	echo "    #define OPENSSL_VERSION_PREREQ(maj, min) \\" >> $(TMPFILE)
	echo "                 (OPENSSL_VERSION_NUMBER >= (((maj) << 28) | \\" >> $(TMPFILE)
	echo "		        ((min) << 20)))" >> $(TMPFILE)
	echo "  #endif" >> $(TMPFILE)
	echo "#endif" >> $(TMPFILE)
	echo "#if !OPENSSL_VERSION_PREREQ(1, 1)" >> $(TMPFILE)
	echo "  #error openssl version 1.1 is required" >> $(TMPFILE)
	echo "#endif" >> $(TMPFILE)
	echo "static void __attribute__((unused)) test(void) {" >> $(TMPFILE)
	echo "    EVP_PKEY_meth_remove(NULL);" >> $(TMPFILE)
	echo "}" >> $(TMPFILE)
	mv $(TMPFILE) $@

CURL_CONFIG ?= curl-config

check-dep-libekmfweb: detect-openssl-version.dep
	$(call check_dep, \
		"libekmfweb", \
		"detect-openssl-version.dep", \
		"openssl-devel version >= 1.1.1", \
		"HAVE_OPENSSL=0", \
		-I. `$(PKG_CONFIG) --cflags --libs libcrypto` -DOPENSSL_SUPPRESS_DEPRECATED)
	$(call check_dep, \
		"libekmfweb", \
		"json-c/json.h", \
		"json-c-devel", \
		"HAVE_JSONC=0")
	$(call check_dep, \
		"libekmfweb", \
		"curl/curl.h", \
		"libcurl-devel", \
		"HAVE_LIBCURL=0" \
		`$(PKG_CONFIG) --cflags --libs libcurl`)
	$(CURL_CONFIG) --ssl-backends | grep OpenSSL >/dev/null 2>&1 || { echo "Error: libcurl is not built with the OpenSSL backend"; exit 1; }
	touch check-dep-libekmfweb

skip-libekmfweb-openssl:
	echo "  SKIP    libekmfweb due to HAVE_OPENSSL=0"

skip-libekmfweb-jsonc:
	echo "  SKIP    libekmfweb due to HAVE_JSONC=0"

skip-libekmfweb-curl:
	echo "  SKIP    libekmfweb due to HAVE_LIBCURL=0"

all: $(BUILD_TARGETS)

ekmfweb.o: check-dep-libekmfweb ekmfweb.c utilities.h cca.h $(rootdir)include/ekmfweb/ekmfweb.h
utilities.o: check-dep-libekmfweb utilities.c utilities.h $(rootdir)include/ekmfweb/ekmfweb.h
cca.o: check-dep-libekmfweb cca.c cca.h utilities.h $(rootdir)include/ekmfweb/ekmfweb.h

libekmfweb.so.$(VERSION): ALL_CFLAGS += -fPIC `$(PKG_CONFIG) --cflags json-c libcurl libcrypto libssl`
libekmfweb.so.$(VERSION): LDLIBS = `$(PKG_CONFIG) --libs json-c libcurl libcrypto libssl` -ldl
libekmfweb.so.$(VERSION): ALL_LDFLAGS += -shared -Wl,--version-script=libekmfweb.map \
	-Wl,-z,defs,-Bsymbolic -Wl,-soname,libekmfweb.so.$(VERM)
libekmfweb.so.$(VERSION): ekmfweb.o utilities.o cca.o $(libs)
	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@
	ln -srf libekmfweb.so.$(VERSION) libekmfweb.so.$(VERM)
	ln -srf libekmfweb.so.$(VERSION) libekmfweb.so

install-libekmfweb.so.$(VERSION): libekmfweb.so.$(VERSION)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 -T libekmfweb.so.$(VERSION) $(DESTDIR)$(SOINSTALLDIR)/libekmfweb.so.$(VERSION)
	ln -srf $(DESTDIR)$(SOINSTALLDIR)/libekmfweb.so.$(VERSION) $(DESTDIR)$(SOINSTALLDIR)/libekmfweb.so.$(VERM)
	ln -srf $(DESTDIR)$(SOINSTALLDIR)/libekmfweb.so.$(VERSION) $(DESTDIR)$(SOINSTALLDIR)/libekmfweb.so
	$(INSTALL) -d -m 755 $(DESTDIR)$(USRINCLUDEDIR)/ekmfweb
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 $(rootdir)include/ekmfweb/ekmfweb.h $(DESTDIR)$(USRINCLUDEDIR)/ekmfweb

install: all $(INSTALL_TARGETS)

clean:
	rm -f *.o libekmfweb.so* check-dep-libekmfweb detect-openssl-version.dep

.PHONY: all install clean skip-libekmfweb-openssl skip-libekmfweb-jsonc \
	skip-libekmfweb-curl install-libekmfweb.so.$(VERSION)

=== libutil/Makefile ===
include ../common.mak

lib := libutil.a

sources := $(filter-out %_example.c,$(wildcard *.c))
objects := $(patsubst %.c,%.o,$(sources))

examples := $(patsubst %.c,%,$(wildcard *_example.c))

all: $(lib)
examples: $(examples)

$(examples): %: %.o $(lib)

$(lib): $(objects)
$(lib): ALL_CFLAGS += -fPIC

install: all

clean:
	rm -f *.o $(lib) $(examples)

=== debian/changelog ===
s390-tools (2.35.0-1) unstable; urgency=medium

  * QA upload.
  * d/control: Drop Vcs fields that do not contain the package.
  * Drop unnecessary Build-Depends: quilt.

 -- Bastian Germann <bage@debian.org>  Tue, 25 Mar 2025 08:34:13 +0100

s390-tools (2.35.0-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.

 -- Gayathri Berli <Gayathri.Berli@ibm.com>  Mon, 25 Nov 2024 07:40:09 +0100

s390-tools (2.16.0-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Cherry-pick upstream patches to fix build failures caused by OpenSSL 3
    deprecation warnings. (Closes: #1080317)
  * Move aliased files from / to /usr (DEP17). (Closes: #1085162)

 -- Michael Biebl <biebl@debian.org>  Wed, 23 Oct 2024 20:16:36 +0200

s390-tools (2.16.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add patches from upstream to fix FTBFS (closes: #1068119)
     - 0001-genprotimg-boot-disable-Warray-bounds-for-now.patch
     - 0001-genprotimg-add-OpenSSL-3.0-support.patch

 -- Johannes Schauer Marin Rodrigues <josch@debian.org>  Tue, 11 Jun 2024 11:15:24 +0200

=== debian/control ===
Source: s390-tools
Section: admin
Priority: important
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper-compat (= 13),
               libz-dev,
               gcc-multilib,
               libglib2.0-dev,
               libfuse-dev,
               libfuse3-dev,
               libncurses-dev,
               libpfm4-dev,
               libssl-dev,
               libcurl4-openssl-dev,
               libcryptsetup-dev,
               libjson-c-dev,
               libxml2-dev
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/ibm-s390-tools/s390-tools

Package: s390-tools
Architecture: s390x
Depends: ${shlibs:Depends}, ${misc:Depends}, perl, gawk
Recommends: sg3-utils
Description: Set of fundamental utilities for Linux on S/390
 The package contains:
  * dasdfmt, which is used to low-level format ECKD-DASDs with either
    the classic disk layout or the new zSeries compatible disk layout.
  * dasdview, which is used to display DASD and VTOC information or to
    dump the contents of a DASD to the console.
  * fdasd, which is used to create or modify partitions on ECKD-DASDs
    formatted with the zSeries compatible disk layout.
  * zipl, which is used to make either dasds or tapes bootable for
    system IPL or system dump.
  * zgetdump, which is used to retrieve system dumps from either tapes
    or dasds.

Package: s390-tools-udeb
Package-Type: udeb
Section: debian-installer
Priority: optional
Architecture: s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Set of utilities for Linux on S/390
 This is a minimal package used by debian-installer.
 This package contains only the binaries dasdfmt and fdasd.

Package: ziomon
Priority: optional
Architecture: s390x
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, blktrace, rsync
Recommends: multipath-tools, lsscsi
Description: Performance analysis and reports for zFCP devices
 Tool set to collect data from zFCP devices for performance analysis
 and reporting.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_CPPFLAGS_MAINT_APPEND = -D_GNU_SOURCE
export DEB_CPPFLAGS_LDFLAGS_APPEND = -rdynamic
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
export HAVE_CARGO=0

%:
	dh $@

override_dh_auto_clean:
	rm -f zipl/boot/.*.d iucvterm/doc/iucvtty.8
	dh_auto_clean

override_dh_auto_build:
	make V=1

override_dh_auto_install:
	make install DESTDIR=$(CURDIR)/debian/tmp
	dh_install

override_dh_fixperms:
	chmod 0644 $(CURDIR)/debian/s390-tools/usr/lib/s390-tools/stage3.bin
	dh_fixperms

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/s390-tools-$1\.tar\.gz/ \
  https://github.com/ibm-s390-tools/s390-tools/tags .*/v?(\d\S+)\.tar\.gz

## s390-tools 2.36.0

=== zipl/boot/Makefile ===
# Common definitions
include ../../common.mak

EMBEDDED_BOOTLOADERS := fba0.bin fba1b.bin fba2.bin \
	  eckd0_ldl.bin eckd0_cdl.bin \
	  eckd1.bin eckd1b.bin eckd2.bin \
	  tape0.bin \
	  eckd2dump_sv.bin tape2dump.bin fba2dump.bin eckd2dump_mv.bin
DEBUG_EMBEDDED_BOOTLOADERS := $(addsuffix .debug,$(EMBEDDED_BOOTLOADERS))
EXTERNAL_BOOTLOADERS := stage3.bin
DEBUG_EXTERNAL_BOOTLOADERS := $(addsuffix .debug,$(EXTERNAL_BOOTLOADERS))

.loaders: $(EMBEDDED_BOOTLOADERS) $(DEBUG_EMBEDDED_BOOTLOADERS)
	touch .loaders

.DEFAULT_GOAL := all
all: .loaders $(EXTERNAL_BOOTLOADERS) $(DEBUG_EXTERNAL_BOOTLOADERS)

clean:
	rm -f -- ./**/*.o *.o *.exec *.bin *.lds .*.lds.d .loaders *.debug

.PHONY: all clean

ifeq ($(HOST_ARCH),s390x)
INCLUDE_PATHS := $(rootdir)/zipl/include $(rootdir)/include
INCLUDE_PARMS := $(addprefix -I,$(INCLUDE_PATHS))

ALL_CFLAGS = $(NO_PIE_CFLAGS) -Os -g $(INCLUDE_PARMS) \
	  -DS390_TOOLS_RELEASE=$(S390_TOOLS_RELEASE) \
	  -fno-builtin -ffreestanding -fno-asynchronous-unwind-tables \
	  -fno-delete-null-pointer-checks -fno-stack-protector \
	  -fexec-charset=IBM1047 -m64 -mpacked-stack \
	  -mstack-size=4096 -mstack-guard=128 -msoft-float \
	  -W -Wall -Wformat-security -fno-sanitize=all -Wno-array-bounds
ALL_LDFLAGS += -fno-sanitize=all

# Prevent make from using some default rules...
%:	%.S

%.o:	%.S
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

%.o:	%.c
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

# Dependencies for the .lds generation
sources_lds_S = $(wildcard *.lds.S)
dependencies_lds_S = $(sources_lds_S:%.lds.S=.%.lds.d)
# Include all ".lds.d" dependency files for all make targets except for "clean"
ifneq ($(MAKECMDGOALS),clean)
-include $(dependencies_lds_S)
endif

%.lds: %.lds.S
	$(CPP) -Wp,-MD,.$@.d,-MT,$@ $(INCLUDE_PARMS) -P -C -o $@ $<
eckd2dump_sv.lds: eckd2dump.lds.S
	$(CPP) -Wp,-MD,.$@.d,-MT,$@ $(INCLUDE_PARMS) -D STAGE2DUMP_TAIL_ADDRESS=0x9ff0 \
	-P -C -o $@ $<
eckd2dump_mv.lds: eckd2dump.lds.S
	$(CPP) -Wp,-MD,.$@.d,-MT,$@ $(INCLUDE_PARMS) -D STAGE2DUMP_TAIL_ADDRESS=0x4ff0 \
	-D ECKD2DUMP_MV -P -C -o $@ $<
stage2.lds: stage2.lds.S
	$(CPP) -Wp,-MD,.$@.d,-MT,$@ $(INCLUDE_PARMS) -D STAGE2DUMP_TAIL_ADDRESS=0x4ff0 \
	-P -C -o $@ $<

fba0.exec eckd0_ldl.exec eckd0_cdl.exec tape0.exec: \
	stage0.lds

eckd1.exec: \
	stage1.lds

eckd1b.exec fba1b.exec: \
	stage1b.lds

eckd2dump_sv.exec: \
	head.o stage2dump.o cio.o eckd2dump.o eckd2dump_sv.o eckd2dump_zlib.o \
	zlib/deflate.o zlib/deftree.o zlib/dfltcc.o zlib/dfltcc_deflate.o \
	libc.o ebcdic.o sclp.o entry.o eckd2dump_sv.lds
eckd2dump_mv.exec: \
	head.o stage2dump.o cio.o eckd2dump.o eckd2dump_mv.o \
	libc.o ebcdic.o sclp.o entry.o eckd2dump_mv.lds
fba2dump.exec: \
	head.o stage2dump.o cio.o fba2dump.o \
	libc.o ebcdic.o sclp.o entry.o stage2.lds
tape2dump.exec: \
	head.o stage2dump.o cio.o tape2dump.o \
	libc.o ebcdic.o sclp.o entry.o stage2.lds
eckd2.exec: head.o stage2.o cio.o eckd2.o libc.o ebcdic.o menu.o sclp.o \
	    kdump2.o kdump.o entry.o stage2.lds
fba2.exec: head.o stage2.o cio.o fba2.o libc.o ebcdic.o menu.o sclp.o \
	   kdump2.o kdump.o entry.o stage2.lds
stage3.exec: head.o stage3.o kdump3.o libc.o ebcdic.o ebcdic_conv.o sclp.o \
	     sclp_stage3.o kdump.o entry.o stage3.lds

%.exec:	%.o
	$(LINK) -Wl,-T,$(filter %.lds,$^) $(NO_PIE_LDFLAGS) $(NO_WARN_RWX_SEGMENTS_LDFLAGS) -Wl,--build-id=none -m64 -static -nostdlib $(filter %.o, $^) -o $@
	@chmod a-x $@

%.bin.debug: %.exec
	$(OBJCOPY) --only-keep-debug $< $@
	@chmod a-x $@

%.bin:	%.exec
	$(OBJCOPY) -O binary $< $@
	@chmod a-x $@

install: $(EXTERNAL_BOOTLOADERS)
	$(INSTALL) -d -m 755 $(DESTDIR)$(TOOLS_LIBDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 $(EXTERNAL_BOOTLOADERS) $(DESTDIR)$(TOOLS_LIBDIR)
else
# Don't generate the dependency files (see `common.mak` for the
# `-include $(dependencies_c)` statement).
.PHONY: $(dependencies_c)

$(EMBEDDED_BOOTLOADERS) $(DEBUG_EMBEDDED_BOOTLOADERS) $(EXTERNAL_BOOTLOADERS) $(DEBUG_EXTERNAL_BOOTLOADERS):
	echo "  SKIP    $@ due to HOST_ARCH != s390x"

install:
	echo "  SKIP    Bootloader installation due to HOST_ARCH != s390x"
endif

=== debian/changelog ===
s390-tools (2.36.0-0ubuntu1) plucky; urgency=medium

  * New upstream release. (LP: #2091549)
    - Remove d/p/fix-unnecessary-qualification-error-in-ffi-rs-.patch
      since this got solved upstream with the help of:
      https://github.com/ibm-s390-linux/s390-tools/commit/6a55d0c
    - Remove d/p/discard-note-package-in-lds-files-to-solve-linker-error.patch
      since this got solved upstream with the help of:
      https://github.com/ibm-s390-linux/s390-tools/commit/fe2d240
    - Modify d/p/vendor-remove-unused-deps.patch to remove new/further
      unused dependencies and to fix existing ones.
    - d/rules:
      - Update tar cmd in vendor-tarball target, to reflect update
        https://github.com/canonical/ubuntu-mir/pull/71/commits/b0f9bf6.
      - Adjust paths for DEP-17 conformity.
    - d/control:
      - Update XS-Vendored-Sources-Rust field.
      - Add Build-Depends libnl-3-dev, libnl-route-3-dev and
        libnl-genl-3-dev, needed by new opticsmon tool.
    - Add d/p/conformance-to-dep17-usr-merge.patch to establish conformance
      to DEP-17 aka /usr-merge. This changes /lib to /usr/lib, /bin to
      /usr/bin and /sbin to /usr/sbin in several places in the Makefile.
    - d/s390-tools.install:
      - Add new tool pvimg, since genprotimg and others are now under pvimg
        and update existing paths.
    - Remove usr/lib/ from d/s390-tools.install.s390x, because it became too
      generic with the DEP-17 changes and attempts to install files twice.
      Instead add dedicated lines for components, like usr/lib/<component>.
    - Move pvapconfig from d/s390-tools.install to d/s390-tools.install.s390x
      since pvapconfig only makes sense on s390x.
    - d/s390-tools-cpuplugd.install: Update path for DEP-17 compliance.
    - d/s390-tools-osasnmpd.install: Update path for DEP-17 compliance.
    - d/s390-tools-statd.install: Update path for DEP-17 compliance.
    - d/s390-tools-chreipl-fcp-mpath.install: Update path for DEP-17 compliance.
    - d/libekmfweb*.install: Adjust path and ensure DEP-17 compliance.
    - d/libkmipclient*.install: Adjust path and ensure DEP-17 compliance.
    - d/s390-tools.links: Create genprotimg link, pointing to pvimg.
    - d/s390-tools-data.install: update stage3*.bin file paths due to pvimg
      changes.
    - d/copyright: Update to reflect changed crate dependencies.
    - d/not-installed: Update paths due to DEP-17 and add entries for files
      that exist in more than one place after build, to avoid lintian warnings
      on having them not installed.
    - Add d/p/lp-2091549-rust-Cargo.toml-Change-to-thin-local-LTO.patch,
      picked from upstream, to change Rust build using LTO 'thin'.
    - Add d/p/lp-2091549-zipl-src-Fix-incorrect-installation-zipl_helper.patch
      to fix zipl helper installation and with that solve upstream issue 178.
    - Update d/s390-tools.lintian-overrides to:
      - Remove overrides for 's390-tools: embedded-library libyaml' detected
        in Rust code, since this got fixed now.
      - Suppress lintian warning:
        'systemd-service-file-refers-to-unusual-wantedby-target',
        since the used 'WantedBy=getty.target' might be unusual, but is valid
        in this case, since this is a requirement for starting the additional
        s390x-specific tty services.

 -- Frank Heimes <frank.heimes@canonical.com>  Mon, 09 Dec 2024 11:38:44 +0100

=== debian/control ===
Source: s390-tools
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian S/390 Team <debian-s390@lists.debian.org>
Uploaders: Bastian Blank <waldi@debian.org>
Build-Depends:
 bsdextrautils,
 cargo,
 debhelper-compat (= 13),
 dh-cargo-tools,
 dh-exec,
 libcryptsetup-dev,
 libcurl4-openssl-dev,
 libfuse3-dev,
 libglib2.0-dev,
 libjson-c-dev,
 liblockfile-dev,
 libncurses-dev,
 libnl-3-dev,
 libnl-genl-3-dev,
 libnl-route-3-dev,
 libpfm4-dev,
 libsnmp-dev,
 libssl-dev,
 libxml2-dev,
 libz-dev,
 pkgconf,
 quilt
Standards-Version: 4.6.2
Homepage: https://github.com/ibm-s390-linux/s390-tools
XS-Build-Indep-Architecture: s390x
XS-Vendored-Sources-Rust: aho-corasick@1.1.2, anstream@0.6.15, anstyle-parse@0.2.0, anstyle-query@1.0.0, anstyle-wincon@3.0.4, anstyle@1.0.10, anyhow@1.0.71, autocfg@1.1.0, base64@0.22.1, bit-set@0.5.3, bit-vec@0.6.3, bitflags@1.3.2, bitflags@2.4.1, bitvec@1.0.1, byteorder@1.4.3, cc@1.0.79, cfg-if@1.0.0, clap@4.5.18, clap_builder@4.5.18, clap_complete@4.5.34, clap_derive@4.5.18, clap_lex@0.7.3, colorchoice@1.0.0, curl-sys@0.4.72+curl-8.6.0, curl@0.4.44, darling@0.20.10, darling_core@0.20.10, darling_macro@0.20.10, deku@0.18.1, deku_derive@0.18.1, enum_dispatch@0.3.13, equivalent@1.0.1, errno-dragonfly@0.1.2, errno@0.3.1, fastrand@2.2.0, fnv@1.0.7, foreign-types-shared@0.1.1, foreign-types@0.3.2, funty@2.0.0, getrandom@0.2.10, hashbrown@0.12.3, hashbrown@0.15.2, heck@0.5.0, ident_case@1.0.1, indexmap@1.9.3, indexmap@2.6.0, is_terminal_polyfill@1.70.1, itoa@1.0.6, lazy_static@1.4.0, libc@0.2.146, libm@0.2.11, libz-sys@1.1.9, linux-raw-sys@0.4.14, log@0.4.19, memchr@2.6.4, no_std_io2@0.8.1, num-traits@0.2.19, once_cell@1.19.0, openssl-macros@0.1.1, openssl-probe@0.1.5, openssl-sys@0.9.104, openssl@0.10.68, pkg-config@0.3.27, ppv-lite86@0.2.17, proc-macro-crate@3.2.0, proc-macro2@1.0.75, proptest@1.5.0, quick-error@1.2.3, quote@1.0.35, radium@0.7.0, rand@0.8.5, rand_chacha@0.3.1, rand_core@0.6.4, rand_xorshift@0.3.0, redox_syscall@0.3.5, regex-automata@0.4.3, regex-syntax@0.8.2, regex@1.10.2, rustix@0.38.3, rustversion@1.0.18, rusty-fork@0.3.0, ryu@1.0.13, schannel@0.1.21, serde@1.0.164, serde_derive@1.0.164, serde_json@1.0.99, serde_test@1.0.176, serde_yaml@0.9.21, socket2@0.4.9, strsim@0.11.1, syn@2.0.47, tap@1.0.1, tempfile@3.8.0, terminal_size@0.3.0, thiserror-impl@1.0.40, thiserror@1.0.40, toml_datetime@0.6.8, toml_edit@0.22.22, unarray@0.1.4, unicode-ident@1.0.9, unsafe-libyaml@0.2.8, utf8parse@0.2.1, vcpkg@0.2.15, wait-timeout@0.2.0, wasi@0.11.0+wasi-snapshot-preview1, winnow@0.6.20, wyz@0.5.1, zerocopy-derive@0.7.32, zerocopy@0.7.32

Package: s390-tools
Architecture: s390x amd64 ppc64el arm64
Priority: important
Depends:
 gawk [s390x],
 s390-tools-data,
 udev [s390x],
 ${misc:Depends},
 ${perl:Depends},
 ${shlibs:Depends},
 ${signing:Depends}
Recommends: sg3-utils [s390x]
Suggests:
 blktrace [s390x],
 lsscsi [s390x],
 mdevctl [s390x],
 multipath-tools [s390x],
 rsync [s390x],
 s390-tools-chreipl-fcp-mpath [s390x],
 s390-tools-cpuplugd [s390x],
 s390-tools-osasnmpd [s390x],
 s390-tools-statd [s390x]
Description: fundamental utilities for Linux on z Systems
 The package contains:
  * dasdfmt, which is used to low-level format ECKD-DASDs with either
    the classic disk layout or the new zSeries compatible disk layout.
  * dasdview, which is used to display DASD and VTOC information or to
    dump the contents of a DASD to the console.
  * fdasd, which is used to create or modify partitions on ECKD-DASDs
    formatted with the zSeries compatible disk layout.
  * zipl, which is used to make either dasds or tapes bootable for
    system IPL or system dump.
  * zgetdump, which is used to retrieve system dumps from either tapes
    or dasds.
  * hsavmcore, which is used to make the dump process with kdump more
    efficient.
  * lshwc, which is used to extract and list complete counter sets

Package: s390-tools-cpuplugd
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: cpuplugd utility for Linux on z Systems
 The package contains cpuplugd hotplug daemon from the s390-tools
 collection of utilities.

Package: s390-tools-statd
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: s390-tools (<<1.34.0-0ubuntu7~)
Replaces: s390-tools (<<1.34.0-0ubuntu7~)
Description: mon_statd monitoring daemons for Linux on z Systems
 The package contains mon_procd and mon_fsstatd z/VM monitoring
 daemons for Linux on z Systems from the s390-tools collection of
 utilities. These tools are also known as mon_statd.

Package: s390-tools-osasnmpd
Architecture: s390x
Depends: udev, ${misc:Depends}, ${shlibs:Depends}
Description: osasnmpd utility for Linux on z Systems
 The package contains osasnmpd monitoring daemon from the s390-tools
 collection of utilities.

Package: s390-tools-zkey
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: zkey utilities for Linux on z Systems
 The package contains zkey and zkey-cryptsetup from the s390-tools
 collection of utilities.

Package: libekmfweb1
Section: libs
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: integration with IBM Enterprise Key Management Foundation
 This package contains library to integrate with IBM Enterprise Key
 Management Foundation. It is used by zkey plugin for pervasive
 encryption support.
 .
 This package contains the runtime library.

Package: libekmfweb-dev
Section: libdevel
Architecture: s390x
Depends: ${misc:Depends}
Description: integration with IBM Enterprise Key Management Foundation (development)
 This package contains library to integrate with IBM Enterprise Key
 Management Foundation. It is used by zkey plugin for pervasive
 encryption support.
 .
 This package contains the development library and headers.

Package: libkmipclient1
Section: libs
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: KMIP client library
 A shared library that provides an KMIP client to communicate with an KMIP
 server. KMIP stands for Key Management Interoperability Protocol, and is an
 extensible communication protocol that defines message formats for the
 manipulation of cryptographic keys on a key management server.
 .
 This package contains the runtime library.

Package: libkmipclient-dev
Section: libdevel
Architecture: s390x
Depends: ${misc:Depends}
Description: KMIP client library (development)
 A shared library that provides an KMIP client to communicate with an KMIP
 server. KMIP stands for Key Management Interoperability Protocol, and is an
 extensible communication protocol that defines message formats for the
 manipulation of cryptographic keys on a key management server.
 .
 This package contains the development library and headers

Package: s390-tools-chreipl-fcp-mpath
Architecture: s390x
Depends: multipath-tools, multipath-tools-boot, udev, ${misc:Depends}
Description: chreipl-fcp-mpath utility for Linux on z Systems
 The package contains chreipl-fcp-mpath toolset from the s390-tools collection
 of utilities, that uses multipath information to change the configured FCP
 re-IPL path on detecting issues with the current path.

Package: s390-tools-data
Architecture: all
Depends: ${misc:Depends}
Replaces: s390-tools (<< 2.28.0-0ubuntu2)
Breaks: s390-tools (<< 2.28.0-0ubuntu2)
Description: fundamental utilities for Linux on z Systems (data files)
 Host architecture independent files used by s390-tools utilities for
 z Systems. Currently this package ships stage3a/b files for genprotimg.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND = -D_GNU_SOURCE
export DEB_LDFLAGS_MAINT_APPEND=-rdynamic
export CARGO = /usr/share/cargo/bin/cargo
export CARGO_VENDOR_DIR = rust-vendor
export CARGO_HOME = $(CURDIR)/debian/cargo_home

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/rustc/architecture.mk
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE

ifeq ($(DEB_HOST_ARCH),s390x)
	options= V=1 HAVE_SNMP=1 SYSTEMDSYSTEMUNITDIR=/usr/lib/systemd/system ZDEV_ALWAYS_UPDATE_INITRD=1 ZKEYKMSPLUGINDIR=/usr/libexec/zkey USRLIB64DIR=/usr/lib/s390x-linux-gnu
endif

# Enable signing in Launchpad only, and on s390x only
SIGN_SIPL=
ifeq ($(DEB_HOST_ARCH),s390x)
	ifneq (,$(wildcard /CurrentlyBuilding))
		SIGN_SIPL=yes
	endif
endif

VENDOR_TARBALL = s390-tools_$(DEB_VERSION_UPSTREAM).orig-$(CARGO_VENDOR_DIR).tar.xz

vendor-tarball-sanity-check:
	if [ -e ../$(VENDOR_TARBALL) ]; then echo "../$(VENDOR_TARBALL) already exists, bailing!"; exit 1; fi

vendor-deps:
	if QUILT_PATCHES=debian/patches quilt applied | grep vendor-remove-unused-deps ; then \
		echo "Detecting patch on vendor dir applied, aborting."; \
		exit 1; \
	fi
	rm -rf $(CARGO_VENDOR_DIR)
	# Deliberately don't use the wrapper, as it expects the configure step
	# to have occurred already.
	# If you have to modify the path here, don't forget to change the README.source doc
	# as well.
	cargo vendor --manifest-path rust/Cargo.toml $(CARGO_VENDOR_DIR)
	# Remove some crates that aren't useful for us and take up a lot of space
	rm -r \
		$(CARGO_VENDOR_DIR)/winapi \
		$(CARGO_VENDOR_DIR)/winapi-* \
		$(CARGO_VENDOR_DIR)/windows-* \
		$(CARGO_VENDOR_DIR)/windows_* \
		# End of list
	# Remove the C sources from the binding crates, we're using the system libs
	rm -r \
		$(CARGO_VENDOR_DIR)/libz-sys/src/zlib \
		$(CARGO_VENDOR_DIR)/libz-sys/src/zlib-ng \
		$(CARGO_VENDOR_DIR)/curl-sys/curl \
		# End of list
	# Remove unused and undesirable data files (e.g. test data for vendored crates)
	rm -r \
		$(CARGO_VENDOR_DIR)/vcpkg/test-data \
		$(CARGO_VENDOR_DIR)/*/tests \
		# End of list
	# Remove the checksum files to allow us to patch the crates to remove extraneous dependencies
	for crate in $(CARGO_VENDOR_DIR)/*; do \
		sed -i 's/^{"files":.*"package":"\([a-z0-9]\+\)"}$$/{"files":{},"package":"\1"}/' $$crate/.cargo-checksum.json; \
	done
	# Cleanup temp files
	rm -rf $(CARGO_HOME)

vendor-tarball: vendor-tarball-sanity-check vendor-deps
	tar --sort=name --mtime=@0 --owner=0 --group=0 --numeric-owner --pax-option=exthdr.name=%d/PaxHeaders/%f,delete=atime,delete=ctime -caf ../$(VENDOR_TARBALL) $(CARGO_VENDOR_DIR)

%:
	dh $@

override_dh_auto_configure:
	DEB_CARGO_CRATE=s390-tools_$(shell dpkg-parsechangelog --show-field Version) \
	$(CARGO) prepare-debian $(CARGO_VENDOR_DIR)
	/usr/share/cargo/bin/dh-cargo-vendored-sources
	dh_auto_configure

override_dh_install:
ifeq ($(DEB_HOST_ARCH),s390x)
	# no dracut
	rm -f debian/tmp/usr/lib/s390-tools/zdev-root-update
	chmod -x debian/tmp/etc/*/*.conf debian/tmp/usr/lib/s390-tools/zfcpdump/zfcpdump-initrd
	dh_install -ps390-tools-cpuplugd
	dh_install -ps390-tools-statd
	dh_install -ps390-tools-osasnmpd
	dh_install -ps390-tools-zkey
	dh_install -ps390-tools-chreipl-fcp-mpath
	dh_install -ps390-tools-data
	dh_install $(if $(SIGN_SIPL),-Xstage3.bin) -Xcpuplugd -Xosasnmpd -Xprocd -Xfsstatd -X60-readahead.rules -Xzkey -Xchreipl-fcp-mpath -Xdata -Xstage3a.bin -Xstage3b_reloc.bin
	$(if $(SIGN_SIPL),echo 'signing:Depends=s390-tools-signed (= $(DEB_VERSION))') >> debian/s390-tools.substvars
else
	dh_install -Xstage3a.bin -Xstage3b_reloc.bin
endif

override_dh_installdocs:
	mv CHANGELOG.md changelog
	dh_installdocs

override_dh_fixperms:
	dh_fixperms
ifeq ($(DEB_HOST_ARCH),s390x)
	chmod 644 debian/s390-tools-zkey/usr/libexec/zkey/zkey-ekmfweb.so
	chmod 644 debian/s390-tools-zkey/usr/libexec/zkey/zkey-kmip.so
endif

override_dh_auto_clean:
	rm -f zipl/boot/.*.d
	dh_auto_clean -- $(options)

override_dh_auto_build:
	dh_auto_build -- $(options)

override_dh_auto_install:
	HAVE_INITRAMFS=1 HAVE_DRACUT=1 dh_auto_install -- $(options)

signing=debian/s390-tools-$(DEB_VERSION)-signing/
signingv=$(signing)/$(DEB_VERSION)
signing_tar=$(DEB_SOURCE)_$(DEB_VERSION)_$(DEB_HOST_ARCH).tar.gz
override_dh_builddeb:
	dh_builddeb
ifeq ($(DEB_HOST_ARCH),s390x)
	mkdir -p $(signingv)/control
	echo 'tarball' >$(signingv)/control/options
	cp debian/tmp/usr/lib/s390-tools/stage3.bin $(signingv)/stage3.bin.sipl
	tar -C $(signing) -czvf $(CURDIR)/../$(signing_tar) .
	dpkg-distaddfile $(signing_tar) raw-signing -
endif
override_dh_clean:
	dh_clean
	rm -rf $(CARGO_HOME)
	rm -rf $(signing)
